---
title: 'ARIA: form role'
slug: Web/Accessibility/ARIA/Roles/Form_Role
tags:
  - ARIA
  - ARIA Role
  - ARIA figure
  - Accessibility
  - Reference
  - Rôle
  - form
---
<div>{{Page("/en-US/docs/Web/Accessibility/ARIA/Roles", "Subnav")}}</div>

<p>The <code>form</code> <a href="/en-US/docs/Web/Accessibility/ARIA/ARIA_Techniques#Landmark_roles">landmark role</a> can be used to identify a group of elements on a page that provide equivalent functionality to an HTML form.</p>

<pre class="brush: html">&lt;div role="form" id="contact-info" aria-label="Contact information"&gt;
  &lt;!-- form content --&gt;
&lt;/div&gt;
</pre>

<p>This is a form that collects and saves a user's contact information.</p>

<div class="warning">
<p><strong>Important</strong>: Use an HTML {{htmlelement("form")}} element to contain your form controls, rather than the ARIA <code>form</code> role, unless you have a very good reason. The HTML <code>&lt;form&gt;</code> element is sufficient to tell assistive technologies that there is a form.</p>
</div>

<h2 id="Description">Description</h2>

<p>A <code>form</code> <a href="/en-US/docs/Web/Accessibility/ARIA/ARIA_Techniques#Landmark_roles">landmark</a> identifies a region of content that contains a collection of items and objects that, as a whole, combine to create a form when no other named landmark is appropriate (e.g. <code><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Main_Role">main</a></code> or <code><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Search_Role">search</a></code>).</p>

<dl>
 <dd>
 <div class="note">
 <p>Using the <a href="/en-US/docs/Web/HTML/Element/form"><code>&lt;form&gt;</code> element</a> will automatically communicate a section of content as a <code>form</code> landmark, if it is provided an accessible name. Developers should always prefer using the correct semantic HTML element over using ARIA.</p>
 </div>
 </dd>
</dl>

<p>Use the HTML <a href="/en-US/docs/Web/HTML/Element/form"><code>&lt;form&gt;</code> element</a> if possible. The &lt;form&gt; element defines a <code>form</code> landmark when it has an accessible name (e.g. <code>aria-labelledby</code>, <code>aria-label</code> or <code>title</code>). Make sure to have a unique label on each form in a document to help users understand the purpose of the form. This label should be visible to all users, not just assistive technology users. Use the <code>search</code> landmark instead of the <code>form</code> landmark when the form is used for search functionality.</p>

<p>Use the <code>role="form"</code> to identify a region of the page; do not use it to identify every form field. Even if you are using the form landmark instead of &lt;form&gt;, you are encouraged to use native HTML form controls like <code>button</code>, <code>input</code>, <code>select</code>, and<code> textarea</code></p>

<h3 id="Associated_WAI-ARIA_Roles_States_and_Properties">Associated WAI-ARIA Roles, States, and Properties</h3>

<p>No role specific states or properties.</p>

<h3 id="Keyboard_Interactions">Keyboard Interactions</h3>

<p>No role specific keyboard interactions</p>

<h3 id="Required_JavaScript_features">Required JavaScript features</h3>

<dl>
 <dt><code>onsubmit</code></dt>
 <dd>The onSubmit event handler handles the event raised when the form is submitted. Anything that is not a <code>&lt;form&gt;</code> cannot be submitted, therefore you would have to use JavaScript to build an alternative data submission mechanism, for example with {{domxref("XMLHTTPRequest")}}.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<pre><span class="tag">&lt;div role="form" id="send-comment" aria-label="Add a comment"&gt;</span>
  &lt;label for="username"&gt;Username&lt;/label&gt;
  &lt;input id="username" name="username" autocomplete="nickname" autocorrect="off" type="text"&gt;

  &lt;label for="email"&gt;Email&lt;/label&gt;
  &lt;input id="email" name="email" autocomplete="email" autocapitalize="off" autocorrect="off" spellcheck="false" type="text"&gt;

  &lt;label for="comment"&gt;Comment&lt;/label&gt;
  &lt;textarea id="comment" name="comment"&gt;&lt;/textarea&gt;

  &lt;input value="Comment" type="submit"&gt;
<span class="tag">&lt;/div</span>&gt;
</pre>

<p>It is recommended to use &lt;form&gt; instead.</p>

<pre><span class="tag">&lt;form id="send-comment" aria-label="Add a comment"&gt;</span>
  ....
<span class="tag">&lt;/form</span>&gt;
</pre>

<h2 id="Accessibility_concerns">Accessibility concerns</h2>

<h3 id="Use_sparingly">Use sparingly</h3>

<p><a href="/en-US/docs/Web/Accessibility/ARIA/ARIA_Techniques#Landmark_roles">Landmark roles</a> are intended to identify larger overall sections of the document. Using too many landmark roles can create "noise" in screen readers, making it difficult to understand the overall layout of the page.</p>

<h3 id="Inputs_are_not_forms">Inputs are not forms</h3>

<p>You do not need to declare <code>role="form"</code> on every <a href="/en-US/docs/Web/HTML/Element#Forms">form element</a> (inputs, text areas, selects, etc.). It should be declared on the HTML element that wraps the form elements. Ideally, use the <a href="/en-US/docs/Web/HTML/Element/form"><code>&lt;form&gt;</code> element</a> as the wrapping element and do not declare <code>role="form"</code>.</p>

<h3 id="Search">Search</h3>

<p>If a form is used to search, <span class="ILfuVd yZ8quc">you should use the more specialized <code>role="search"</code> value</span>.</p>

<h3 id="Labeling_landmarks">Labeling landmarks</h3>

<p>Each <a href="/en-US/docs/Web/HTML/Element/form"><code>&lt;form&gt;</code> element</a> and form <code>role</code> that needs to be exposed as a landmark must be given an accessible name. This name will allow an assitive technology user to be able to quickly understand the purpose of the form landmark.</p>

<p>Use an <code>aria-labelledby</code>, <code>aria-label</code> or <code>title</code>  on the same element that was given the <code>role="form"</code> to provide it an accessible name.</p>

<h4 id="Using_roleform">Using <code>role="form"</code></h4>

<pre class="brush: html">&lt;div role="form" id="gift-cards" aria-label="Purchase a gift card"&gt;
  &lt;!-- form content --&gt;
&lt;/div&gt;</pre>

<h4 id="Redundant_descriptions">Redundant descriptions</h4>

<p>Screen readers will announce the type of role the landmark is. Because of this, you do not need to describe what the landmark is in its label. For example, a declaration of <code>role="form"</code> with an of <code>aria-label="Contact form"</code> may be announced redundantly as, "contact form form".</p>

<h2 id="Best_practices">Best practices</h2>

<h3 id="Prefer_HTML">Prefer HTML</h3>

<p>Using the <a href="/en-US/docs/Web/HTML/Element/form"><code>&lt;form&gt;</code> element</a> will automatically communicate a section has a role of <code>form</code>. If at all possible, prefer using it instead.</p>

<h3 id="Added_benefits">Added benefits</h3>

<p>Certain technologies such as browser extensions can generate lists of all landmark roles present on a page, allowing non-screen reader users to also quickly identify and navigate to large sections of the document.</p>

<ul>
 <li><a href="http://matatk.agrip.org.uk/landmarks/">Landmarks browser extension</a></li>
</ul>

<ul>
 <li></li>
</ul>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
  </tr>
  <tr>
   <td>{{SpecName("ARIA","#form","ARIA Form Role")}}</td>
   <td>{{Spec2('ARIA')}}</td>
  </tr>
  <tr>
   <td>{{SpecName("ARIA Authoring Practices","#form","Role Form")}}</td>
   <td>{{Spec2('ARIA Authoring Practices')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Screen_reader_support">Screen reader support</h2>

<p>TBD</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/HTML/Element/form">&lt;form&gt;: The Form element</a></li>
 <li><a href="/en-US/docs/Web/HTML/Element/legend">&lt;legend&gt;: The Legend element</a></li>
 <li><a href="https://www.w3.org/TR/wai-aria/#form">form (role): Accessible Rich Internet Applications (WAI-ARIA) 1.1</a></li>
 <li><a href="/en-US/docs/Web/Guide/HTML/Using_HTML_sections_and_outlines">Using HTML sections and outlines</a></li>
 <li><a href="/en-US/docs/Web/Accessibility/ARIA/ARIA_Techniques#Landmark_roles">Landmark roles: Using ARIA: Roles, States, and Properties</a></li>
 <li><a href="https://www.scottohara.me/blog/2018/03/03/landmarks.html">Accessible Landmarks | scottohara.me</a></li>
 <li><a href="https://developer.paciellogroup.com/blog/2013/02/using-wai-aria-landmarks-2013/">Using WAI-ARIA Landmarks – 2013 | The Paciello Group</a></li>
</ul>
